Program SortUtil (Input,Output);
Uses    Dos;

Const
        BitMask         : Array[0..15] of Word =
                          (    1,    2,    4,    8,   16,   32,   64,  128,
                             256,  512, 1024, 2048, 4096, 8192,16384,32768);
        CommandLnSwitch : Set of Char = ['/','-'];
        NumberFieldEnd  : String[20]    = '. ';
        TextFileDefault : String[80]    = 'SORTER.TXT';
        Error_Array     : Array [1..5] of String [40] =
                          (
                           ('Source file not available'),
                           ('Very large file. Sorry :('),
                           ('Source file not renamed'),
                           (''),
                           ('')
                           );
        TextSortColumn  : Byte          = 1;
        TextSortLength  : Byte          = 255;
        TextNumberField : Byte          = 1;
                            { - ᨬ   ப }
        TextFirstLine   : Word          = 1;
        TextNumLines    : Word          = 999;
        TextBeginLine   : Word          = 0;
        TextTotalLines  : Word          = 400;
        TextSortMode    : Word          = 0;
        {
  15             8 7             0
  Ŀ
  
                   0 - Latin UpCase
                 1 0 - Russian UpCase
                2 1 - Not Rename Old File to '*.BAK'
               3 1 - Numerate Output Strings
              4 1 - Input file  = Input stream
             5 1 - Output file = Output stream
            6 1 -
           7 1 -
          8 1 -
         9 1 -
        10 1 -
       11 1 -
      12 1 -
     13 1 - Reverse sorting
    14 1 - Not Showing Any Messages
   15 1 - Not Showing Error Messages
        }
Type
        StringArray = Array[0..405] of String[160];
var
        BoolArray       : Array [0..15] of Boolean;
        TXT             : Text;
        F               : File;
        S,S1,S2         : String;
        A               : ^StringArray;
        Index           : Word;
        Flag,Flag1      : Boolean;
        B,C             : Word;
        I,J,K           : Byte;
        Flag2           : Byte;

Function  Str2Byte(S:String):LongInt;
Var
        I,J,K           : LongInt;
        Result          : Integer;
  begin
    Val(S,I,Result);
    Str2Byte:=I;
  end;

Function  UpCaseStr(S:String):String;
Var
      LS    : Byte Absolute S;
      I     : Byte;
      C     : Char;
      CB    : Byte Absolute C;

  begin
    For I:=1 to LS do
      begin
        C:=S[I];
        Case C of
          'a'..'z'            : begin
                                  if Not BoolArray[0] then CB:=CB-32;
                                end;
          ''..''            : begin
                                  if Not BoolArray[1] then CB:=CB-32;
                                end;
          ''..''            : begin
                                  if Not BoolArray[1] then CB:=CB-80;
                                end;
        end;
        S[I]:=C;
      end;
    UpCaseStr:=S;
  end;

Procedure CheckString(S1,S2    :String;
                      var Flag1:Byte);
Var
        I,J,K,L : Byte;                   { Flag1 : Byte     = 0 -  }
        LS1     : Byte Absolute S1;       {                    1 -  }
        LS2     : Byte Absolute S2;       {                    2 -  }
        Flag    : Boolean;
  begin
    if LS1<TextSortColumn then
      begin
        Flag1:=2;
        Exit;
      end;
    if LS2<TextSortColumn then
      begin
        Flag1:=1;
        Exit;
      end;
    S1:=UpCaseStr(Copy(S1,TextSortColumn,TextSortLength));
    S2:=UpCaseStr(Copy(S2,TextSortColumn,TextSortLength));
    L:=LS1;
    if L>LS2 then L:=LS2;
    Flag1:=0;
    For I:=1 to L do
      begin
        if S1[I]>S2[I] then
          begin
            K:=I;
            I:=L;
            Flag1:=1;
          end
          else
            begin
              if S1[I]<S2[I] then
                begin
                  K:=I;
                  I:=L;
                  Flag1:=2;
                end;
            end;
      end;
    if Flag1=0 then
      begin
        if LS1>LS2 then Flag1:=1;
        if LS1<LS2 then Flag1:=2;
      end;
  end;

Procedure Programm_Banner;
  begin
    if Not BoolArray[14] then
      begin
        Writeln(OutPut);
        Writeln(OutPut,'String Sorter v.2.0');
        Writeln(OutPut,'(c) 1995 CSC Ltd. All right reserved.');
        Writeln(OutPut,'Author: Alexander Boychenko ( shurik@csc.kiev.ua )');
        Writeln(OutPut);
      end;
  end;

Procedure Convert_SortMode;
Var   I : Byte;
  begin
    For I:=0 to 15 do
      begin
        if (TextSortMode and BitMask[I])>0
           then BoolArray[I]:=True
           else BoolArray[I]:=False;
      end;
  end;

Procedure Prog_ErrorExit(N:Byte);
  begin
    Dispose(A);
    if N=0 then Halt(0);
    If Not BoolArray[15] then
      begin
        Writeln(' Fatal Error:   ',Error_Array[N]);
      end;
    Halt(N);
  end;

Procedure Read_Parameters;
Var
        I,J,K       : Byte;
        S,S1,S2     : String;
        W2          : Word;
  begin
    Convert_SortMode;
    if ParamCount>0 then
      begin
        TextFileDefault:=ParamStr(1);
      end;
    if ParamCount>1 then
      begin
        For I:=2 to ParamCount do
          begin
            S:=ParamStr(I);
            if (S[1] in CommandLnSwitch) then
              begin
                S1:=Copy(S,3,99);
                W2:=Str2Byte(S1);
                Case UpCase(S[2]) of
                  'R'     : Begin
                              BoolArray[1]:=True; {   ᪨ UpCase }
                            end;
                  'M'     : Begin
                              BoolArray[14]:=True; {  뢮 ᮮ饭 }
                            end;
                  'E'     : Begin
                              BoolArray[15]:=True; {  뢮 ᮮ饭  訡 }
                            end;
                  'T'     : Begin
                              BoolArray[0]:=True; {   ⨭᪨ UpCase }
                            end;
                  'A'     : Begin
                              BoolArray[0]:=True; {  㦥 UpCase  }
                              BoolArray[1]:=True;
                            end;
                  'B'     : Begin
                              BoolArray[2]:=True; {  ࠭ 室 䠩 }
                            end;
                  'V'     : Begin
                              BoolArray[13]:=True; { ⭠ ஢ }
                            end;
                  'N'     : Begin
                              BoolArray[3]:=True; { 㬥஢ ப  䠩 }
                            end;
                  'C'     : Begin
                              TextSortColumn  := W2; { ࠡ뢠  }
                            end;                     { ⮫ #...   }
                  'L'     : Begin
                              TextSortLength  := W2; { 뢠 N }
                            end;                     { ᨬ }
                  'F'     : Begin
                              TextNumberField  := W2; {  ஢ }
                            end;
                  'S'     : Begin
                              TextFirstLine    := W2; { - ய᪠ ப }
                            end;
                  'W'     : Begin
                              TextNumLines  := W2; { ᥣ ப  ࠡ⪨ }
                            end;
                  'X'     : Begin
                              TextTotalLines:= W2; { 쪮 ப  }
                            end;
                  'Y'     : Begin
                              TextBeginLine:= W2; {  ࢮ ப }
                            end;
                end;
              end
              else
              begin
                TextFileDefault:=S;
              end;
          end;
      end;
  end;

Function Load_Source:Boolean;
Var      Flag                : Boolean;
         W1                  : Word;
  begin
    Assign(TXT,TextFileDefault);
    {$I-}
    Reset(TXT);
    {$I+}
    if IOResult<>0 then
      begin
        Prog_ErrorExit(1);
      end;
    Index:=0;
    W1:=0;
    Flag:=False;
    While Not Flag do
      begin
        If not Eof(TXT) then
          begin
            Readln(TXT,S);
            Inc(W1);
            if W1>TextBeginLine then
              begin
                A^[Index]:=S;
                Inc(Index);
              end;
          end
          else Flag:=True;
        if Index>TextTotalLines then Flag:=True;
        if Index>759 then
          begin
            Prog_ErrorExit(2);
          end;
      end;
    Dec(Index);
    Close(TXT);
  end;

Procedure Sort_Array;
Var
        EndLine : Integer;
  begin
    Flag:=True;
    EndLine:=TextNumLines+TextFirstLine;
    if Index < EndLine then
      begin
        EndLine:=Index;
      end;
    While Flag do
      begin
        Flag:=False;
        For B:=TextFirstLine-1 to EndLine-1 do
          begin
            S1:=A^[B];
            S2:=A^[B+1];
            CheckString(S1,S2,Flag2);
            if BoolArray[13] then
              begin
                If Flag2=2 then
                  begin
                    A^[B]  := S2;
                    A^[B+1]:= S1;
                    Flag:=True;
                  end;
              end
              else
              begin
                If Flag2=1 then
                  begin
                    A^[B]  := S2;
                    A^[B+1]:= S1;
                    Flag:=True;
                  end;
              end;
          end;
      end;
  end;

Procedure Write_Target;
Var
        FSource     : File;
        Dir         : DirStr;
        Path        : PathStr;
        Name        : NameStr;
        Ext         : ExtStr;
  begin
    if Not BoolArray[2] then
      begin
        Assign(FSource,TextFileDefault);
        FSplit (TextFileDefault, Dir, Name, Ext);
        Path:=Dir+Name+'.BAK';
        {$I-}
        Rename(FSource,Path);
        {$I+}
        If IOResult<>0 then Prog_ErrorExit(3);
      end;
    Assign(TXT,TextFileDefault);
    ReWrite(TXT);
    For B:=0 to Index do
      begin
        if BoolArray[3] then
          begin
            Write(TXT,B+1 : TextNumberField, NumberFieldEnd);
          end;
        Writeln(TXT,A^[B]);
      end;
    Close(TXT);
  end;

begin
  New(A);
  Read_Parameters;
  Programm_Banner;
  If Load_Source then
    begin
      Sort_Array;
      Write_Target;
    end;
end.
